<?

    //-----------------------------------------------------------------
    // scs.intranet interface
    //
    // (C) 2002 lgsd developer team
    // this module is released under the GPL (GNU Public License v2)
    // cvs: $Id$
    //-----------------------------------------------------------------


//--------------------------------------------------------------------
// CSCSIntranet class
// this is the interface class to gain access to scs forms.
// take a look at the included example and online documentation
// for more information
//--------------------------------------------------------------------

class CSCSIntranet {

    //----------------------------------------------------------------
    // scs host address
    //----------------------------------------------------------------
    var $scsHostAddr;    
    var $scsHostPort;
    
    //----------------------------------------------------------------
    // css to use
    //----------------------------------------------------------------
    var $css_fontStyle;
    var $css_inputStyle;
    var $css_selectStyle;
    var $css_checkboxStyle;
    var $css_headingStyle;
    var $css_radiobuttonStyle;
    var $css_textareaStyle;

    //----------------------------------------------------------------
    // navigation point
    //----------------------------------------------------------------
    var $scsNavigationPoint;


    //----------------------------------------------------------------
    // constructor
    //----------------------------------------------------------------
    function CSCSIntranet ()
    {
	$scsHostAddr = "";
	$scsHostPort = -1;

	$css_fontStyle = "";
	$css_inputStyle = "";
	$css_selectStyle = "";
	$css_checkboxStyle = "";
	$css_headingStyle = "";
	$css_radiobuttonStyle = "";
	$css_textareaStyle = "";
    
	$scsNavigationPoint = "";
    }


    //----------------------------------------------------------------
    // scs host address
    //----------------------------------------------------------------
    function setHost ($addr, $port)
    {
	$this->scsHostAddr = $addr;
	$this->scsHostPort = $port;
    }
    

    //----------------------------------------------------------------
    // css functions
    //----------------------------------------------------------------
    function set_FontStyle ($style)
    {
	$this->css_fontStyle = $style;
    }
    
    function set_InputStyle ($style)
    {
	$this->css_inputStyle = $style;
    }

    function set_SelectStyle ($style)
    {
	$this->css_selectStyle = $style;
    }
    
    function set_CheckboxStyle ($style)
    {
	$this->css_checkboxStyle = $style;
    }

    function set_headingStyle ($style)
    {
	$this->css_headingStyle = $style;
    }

    function set_radiobuttonStyle ($style)
    {
	$this->css_radiobuttonStyle = $style;
    }

    function set_radiobuttonStyle ($style)
    {
	$this->css_radiobuttonStyle = $style;
    }

    
    //----------------------------------------------------------------
    // navigation point
    //----------------------------------------------------------------
    function setNavigationPoint ($navp)
    {
	$this->scsNavigationPoint = $navp;
    }


    //----------------------------------------------------------------
    // get form
    //----------------------------------------------------------------
    function getForm ()
    {
	global $HTTP_POST_VARS;
	
	// compose url: css components
	$css_URL  = "css_fontstyle=$this->css_fontStyle";
	$css_URL .= "&css_inputstyle=$this->css_inputStyle";
	$css_URL .= "&css_selectstyle=$this->css_selectStyle";
	$css_URL .= "&css_checkboxstyle=$this->css_checkboxStyle";
	$css_URL .= "&css_headingstyle=$this->css_headingStyle";
	$css_URL .= "&css_radiobuttonstyle=$this->css_radiobuttonStyle";
	$css_URL .= "&css_textareastyle=$this->css_textareaStyle";
	
	$form_URL = "";
	
	reset ($HTTP_POST_VARS);
	
	while (list ($key, $value) = each ($HTTP_POST_VARS))
	{
	    if (strpos ($key, "scs_") === 0)
	    {
		if (strlen ($form_URL) == 0)
		{
		    $form_URL = "$key=" . urlencode ($value);
		} else {
		    $form_URL = $form_URL . "&$key=" . urlencode ($value);
		}
	    }
	}
	
	// now decide the next step
	if (strlen ($this->scsNavigationPoint) > 0)
	{
	    // load a plugin
	    $scsURL = "http://" . $this->scsHostAddr . ":" . $this->scsHostPort . "/" . $this->scsNavigationPoint . "?formexport=true&" . $css_URL;
	} else {
	    if (strlen ($form_URL) == 0)
	    {
		echo "please choose a plugin<br>\n";
		
		return;
	    } else {
		$scsURL = "http://" . $this->scsHostAddr . ":" . $this->scsHostPort . "/formExport/?" . $form_URL . "&" . $css_URL;
	    }
	}
	
	$fd = fopen ($scsURL, "r");
	
	while (!feof ($fd))
	{
	    $line = fgets ($fd, 1024);
	    echo $line;
	}
	
	fclose ($fd);
    } 
   
   
    //----------------------------------------------------------------
    // get modules
    //----------------------------------------------------------------
    function getModules ()
    {
	$scsModules = array();
	
	$fd = fopen ("http://$this->scsHostAddr:$this->scsHostPort/modules?formexport=true", "r");	
	
	$pluginName = "";
	$pluginDesc = "";
	
	while (!feof ($fd))
	{
	    $line = fgets ($fd, 2048);
	    
	    if (strpos ($line, ":") === 0)
	    {
		if (strlen ($pluginDesc) > 0)
		{
		    $scsModules = array_merge ($scsModules, array ("$pluginName" => "$pluginDesc"));
		    $pluginDesc = "";
		}

		$line = trim ($line);
		$pluginName = substr ($line, 1);

	    } else {
		$pluginDesc = $pluginDesc . $line;
	    }
	}
	
	$scsModules = array_merge ($scsModules, array ("$pluginName" => "$pluginDesc"));
	
	fclose ($fd);
	
	return $scsModules;
    }
    
}
