<?

  // XML::MODUL   (Class CSCSaccess)
  // XML::VERSION (0.035)
  // XML::AUTHOR  (trag, lgsd developer team)
  // XML::INFO    (ber diese Klasse wird die Kommunikation zum SCS geregelt)

  //-----------------------------------------------------------------
  // this is the scs access modul written in php
  // you will achieve access to scs by using this class
  // use this library for including scs support in your own
  // php application or intranet system
  //
  // (C) 2002 lgsd developer team
  // this module is released under the GPL (GNU Public License v2)
  //-----------------------------------------------------------------


  // XML::COMMENT (global variables, but they are only used in this modul, don't use it in your program!)
  $SCSaccess_depth = 0;
  $SCSaccess_successful = false;
  $SCSaccess_var_type = "undefined";
  $SCSaccess_var_prefix = "";
  $SCSaccess_var_name = "";


  function startElement ($parser, $name, $attrs)
  {
    global $SCSaccess_depth, $SCSaccess_var_type, $SCSaccess_var_prefix, $SCSaccess_result, $SCSaccess_var_name, $SCSaccess_successful;

    $SCSaccess_depth++;

    if ($SCSaccess_depth > 3)
    {
	if ($name == "unknownclass")
	{
	    $SCSaccess_successful = false;
	} else {
	    // new result variable
	    $SCSaccess_var_prefix = "";

    	    while (list ($n, $v) = each ($attrs))
	    {
		if ($n == "prefix")
		{
		    $SCSaccess_var_prefix = $v;
		} else if ($n == "type") {
		    $SCSaccess_var_type = $v;
		}
	    }

	    // append element
	    if ($SCSaccess_var_prefix != "")
	    {
		$varname = $SCSaccess_var_prefix . "." . $name;
	    } else {
		$varname = $name;
	    }

	    $SCSaccess_var_name = $varname;
	    $newelement = array ("$varname" => "");

	    $SCSaccess_result = array_merge ($SCSaccess_result, $newelement);
	}

    }
  }


  function endElement ($parser, $name)
  {
    global $SCSaccess_depth;

    $SCSaccess_depth--;
  }


  function characterData ($parser, $data)
  {
    global $SCSaccess_depth, $SCSaccess_var_type, $SCSaccess_result, $SCSaccess_var_name;

    if ($SCSaccess_depth <= 3)
    {
	return;
    }

    if ($SCSaccess_var_type == "integer")
    {
	$SCSaccess_result[$SCSaccess_var_name] = (int) $data;
    } else if ($SCSaccess_var_type == "boolean") {
	if ($data == "true")
	{
	    $SCSaccess_result[$SCSaccess_var_name] = true;
	} else {
	    $SCSaccess_result[$SCSaccess_var_name] = false;
	}
    } else {
	$SCSaccess_result[$SCSaccess_var_name] = $data;
    }
  }


  // XML::COMMENT (Klasse erstellen)
  class CSCS
  {

    var $rpcHost;

    var $rpcPort;

    var $rpcIO;

    var $depth;

    var $rpcResult;

    function SCS ()
    {
	  // XML::COMMENT (initialization)
    }


    function SCS ($host, $port)
    {
	$this->rpcHost = $host;
	$this->rpcPort = $port;
    }


    function setPort ($rpcport)
    {
	$this->rpcPort = $rpcport;
    }


    function setHost ($rpchost)
    {
	$this->rpcHost = $rpchost;
    }


    function rpcCall ($function, $params)
    {
	global $SCSaccess_depth, $SCSaccess_result, $SCSaccess_successful;

	$rpcIO = fsockopen ($this->rpcHost, $this->rpcPort);

	if (!$rpcIO)
	{
	    return -1;
	} else {
	    fputs ($rpcIO, "<scs>\n\t<rpc>\n\t\t<call function=\"$function\" rpcport=\"-1\">\n");

	    $akeys = array_keys ($params);

	    for ($i = 0; $i < count ($akeys); $i++)
	    {
		fputs ($rpcIO, "\t\t\t<" . $akeys[$i] . " type=\"");

		if (gettype ($params[$akeys[$i]]) == "string")
		{
		    fputs ($rpcIO, "string\"");
		} else if (gettype ($params[$akeys[$i]]) == "integer") {
		    fputs ($rpcIO, "integer\"");
		} else if (gettype ($params[$akeys[$i]]) == "boolean") {
		    fputs ($rpcIO, "boolean\"");
		}
		fputs ($rpcIO, ">" . $params[$akeys[$i]] . "</" . $akeys[$i] . ">\n");
	    }

	    fputs ($rpcIO, "\t\t</call>\t</rpc>\n</scs>\n\xff");

	    // XML::COMMENT (now read the answer)
	    $tmpfilename = tempnam ("", "scs");
	    $fp = fopen ($tmpfilename, "w");

	    while (!feof ($rpcIO))
	    {
		$line = fgets ($rpcIO, 1024);
		fputs ($fp, $line);

		if ($line == "</scs>\n")
		{
		    break;
		}
	    }

	    fclose ($fp);
	    $fp = fopen ($tmpfilename, "r");

	    $xml_parser = xml_parser_create ();
	    xml_parser_set_option ($xml_parser, XML_OPTION_CASE_FOLDING, 0);

	    xml_set_element_handler ($xml_parser, "startElement", "endElement");
	    xml_set_character_data_handler ($xml_parser, "characterData");

	    $SCSaccess_depth = 0;
	    $SCSaccess_result = array ();
	    $SCSaccess_successful = true;

	    while ($data = fread ($fp, 4096))
	    {
		if (!xml_parse ($xml_parser, $data, feof ($fp)))
		{
		    die ("Error during xml parsing!");
		}
	    }

	    xml_parser_free ($xml_parser);

	    $this->rpcResult = $SCSaccess_result;

	    return $SCSaccess_successful;
	}
  }

}
