<?php
  // XML::MODUL   (Script2Doc)
  // XML::VERSION (0.035)
  // XML::AUTHOR  (::[CTH]Goldenhawk::)
  // XML::INFO    (CScript2Doc erstellt aus PHP-/Perl-Scripts Onlinedokumentationen)


  // XML::COMMENT (Vesrion, Name und Autor festlege)
  $VERSION = "0.035";
  $NAME    = "CScript2Doc";
  $AUTHOR  = "::[CTH]Goldenhawk::";

  class CScript2Doc
  {
    // XML::FUNC::setInput ($self->setInput($opts))
    // XML::DESC::setInput (Setzt die Eingabe-Dateien)
    // XML::VERSION::setInput  (1.1)
    // XML::RETURN::setInput (BOOl)
    function setInput($opts)
    {
      // XML::COMMENT (Globales Array fr die geparsten Funktionen anlegen)
      $this->var_parsed_functions = array();

	  // XML::COMMENT (Falls keine Ausgabedatei erstellt wurde, wird automatisch eine Datei out.xml erstellt)
	  (!$opts[output_file]) ? ($this->output_file = "./out.xml") : ($this->output_file = $opts[output_file]);

	  // XML::COMMENT (Falls bereits die angegebene Datei existiert, wird diese gelscht)
	  (is_file($this->output_file)) ? (unlink($this->output_file)) : ($dummy);

	  // XML::COMMENT (Array festlegen)
	  $g_files = array();
	  // XML::COMMENT (Falls als Eingabe ein Ordner festgelegt wurde)
	  if ($opts[type] == 'dir')
	  {
		// XML::COMMENT (Falls "/" am Ende fehlt, anhngen)
		(!preg_match("/(.*)\/$/",$opts[input])) ? ($opts[input] .= "/") : ($dummy);

	    $p_dir = opendir("$opts[input]");
	    while ($file = readdir($p_dir))
	    {
          if ($file != "." && $file != ".." && (preg_match("/(.*)php$/",$file) || preg_match("/(.*)pl$/",$file)))
          {
            if (!is_dir($opts[input].$file))
            {
              // XML::COMMENT (Datei in Array pushen)
              array_push($g_files,$opts[input].$file);
            }
          }
        }
	  }
	  else
	  {
	    // XML::COMMENT (Angegebene Datei in Array pushen)
	    array_push($g_files,$opts[input]);
	  }
	  // XML::COMMENT (Array $ar_files global verfgbar machen)
	  if ($this->debug)
	  {
	    for ($cnt=0;$cnt<count($g_files);$cnt++)
	    {
	      print $g_files[$cnt]."\n";
	    }
	  }
	  $this->ar_files = $g_files;
	  return true;
    }

    // XML::FUNC::parseInput ($self->parseInput($opts))
    // XML::DESC::parseInput (ruft die Parsing-Routine fr jede Datei auf)
    // XML::VERSION::parseInput  (1.0)
    // XML::RETURN::parseInput (BOOl)
    function parseInput()
    {
      // XML::COMMENT (Dateien parsen)
      for ($cnt=0;$cnt<count($this->ar_files);$cnt++)
      {
        ($this->debug) ? (print $this->ar_files[$cnt]."\n") : ($dummy);

        // XML::COMMENT (Aktuell zu parsende Datei setzen)
        $this->var_actfile = $this->ar_files[$cnt];

        // XML::COMMENT (Onlindokumentation Child-Object erstellen)
        $this->priv_setDocu('file_entry');

        // XML::COMMENT (Datei parsen)
        $this->priv_parseFile();

	    // XML::COMMENT (Funktionen parsen)
	    $this->priv_setDocuFunctions();

	    // XML::COMMENT (Onlinedokumentation Child-Object(Outry) erstellen)
	    $this->priv_setDocu('file_outry');

	    // XML::COMMENT (Variablen zerstren)
	    unset($this->var_parsed_functions,$this->var_docu_header,$this->var_docu_body,$this->var_docu_functions);
      }

      // XML::COMMENT (Nun die Datei abschlieen)
      $this->priv_setDocu('docu_end');
      $this->priv_createDocu();
    }

    // XML::FUNC::priv_parseFile ($self->parseFile($file))
    // XML::DESC::priv_parseFile (parst die Eingabe-Dateien)
    // XML::VERSION::priv_parseFile  (1.0)
    // XML::RETURN::priv_parseFile (BOOl)
	function priv_parseFile()
	{
	  // XML::COMMENT (Datei ffnen)
	  ($p_file = fopen($this->var_actfile,"r")) ? ($dummy) : ($this->errcode = "Could not open \"$file\"");
	  while (!feof($p_file))
	  {
	    $line = fgets($p_file,1024);
	    if (preg_match("/\/\/ XML::(\S*)(\s*)\((.*)\)/",$line,$ret) || preg_match("/# XML::(\S*)(\s*)\((.*)\)/",$line,$ret))
	    {
	      $this->var_actkey = $ret[1];
	      $this->var_actval = $ret[3];
	      $this->var_actval = preg_replace("//i","ue",$this->var_actval);
	      $this->var_actval = preg_replace("//i","oe",$this->var_actval);
	      $this->var_actval = preg_replace("//i","ae",$this->var_actval);
	      $this->var_actval = preg_replace("//i","Ue",$this->var_actval);
	      $this->var_actval = preg_replace("//i","Oe",$this->var_actval);
	      $this->var_actval = preg_replace("//i","Ae",$this->var_actval);
	      $this->var_actval = preg_replace("//i","ss",$this->var_actval);

		  // XML::COMMENT (HTML-Charakterzeichen umwandeln)
		  $this->var_actval = htmlentities($this->var_actval);

		  $this->priv_setDocu('text');
	    }
	  }
	  fclose($p_file);
	}

    // XML::FUNC::priv_setDocu ($self->setDocu())
    // XML::DESC::priv_setDocu (Fgt Daten zur Onlinedokumentation hinzu)
    // XML::VERSION::priv_setDocu  (1.0)
    // XML::RETURN::priv_setDocu (BOOl)
	function priv_setDocu($m_what)
	{
	  // XML::COMMENT (Falls noch keine globlae Variable existiert -> erstellen)
	  if (!isset($this->var_COMPLETE_DOCU))
	  {
	    $this->var_COMPLETE_DOCU = "<?xml version=\"1.0\"?>\n<!DOCTYPE config>\n\n<!-- this document was automatically generated by CScript2Doc -->\n\n";
		$this->var_COMPLETE_DOCU .= "<docu>\n";
	  }

	  // XML::COMMENT (Nun Operationen ausfhren)
	  if ($m_what == 'file_entry')
	  {
	    $this->var_docu_header = "  <part file=\"$this->var_actfile\"";
	    ($this->debug) ? (print "  Creating Header for $this->var_actfile\n") : ($dummy);
	  }
	  elseif ($m_what == 'file_outry')
	  {
	    // XML::COMMENT (Header abschlieen)
	    $this->var_docu_header .= ">\n\n";

		($this->debug) ? (print "  Header: $this->var_docu_header") : ($dummy);
	    $this->var_docu_body .= $this->var_docu_functions;

	    // XML::COMMENT (Body abschlieen)
	    $this->var_docu_body .= "  </part>\n\n";

	    $this->var_docu_header .= $this->var_docu_body;

		// XML::COMMENT (Header und Body in Datei einfgen)
		$this->var_COMPLETE_DOCU .= $this->var_docu_header;
		//$this->var_COMPLETE_DOCU .= $this->var_docu_body;
	  }
	  // XML::COMMENT (Dokument abschlieen)
	  elseif ($m_what == 'docu_end')
	  {
	    $this->var_COMPLETE_DOCU .= "</docu>\n";
	  }
	  elseif ($m_what == 'text')
	  {
	    // XML::COMMENT (Falls die Keys Headerinformationen sind)
	    if ($this->var_actkey == 'MODUL')
	    {
	      $this->var_docu_header .= " modulname=\"$this->var_actval\"";
	    }
		elseif ($this->var_actkey == 'VERSION')
		{
		  $this->var_docu_header .= " version=\"$this->var_actval\"";
		}
		elseif ($this->var_actkey == 'AUTHOR')
		{
		  $this->var_docu_header .= " author=\"$this->var_actval\"";
		}
		elseif ($this->var_actkey == 'INFO')
		{
		  $this->var_docu_header .= " info=\"$this->var_actval\"";
		}
		// XML::COMMENT (Andernfalls...)
		elseif ($this->var_actkey != 'COMMENT')
		{
		  $array = split("::",$this->var_actkey);
		  $func_name = $array[1];
		  $func_key = "var_func_".$array[1]."_".$array[0];
		  $this->var_parsed_functions["$func_name"] = $func_name;

		  // XML::COMMENT (Funktionsnamen festlegen)
		  $this->$func_key = $this->var_actval;
		}
	  }
	}

    // XML::FUNC::priv_setDocuFunctions ($self->setDocuFunctions())
    // XML::DESC::priv_setDocuFunctions (Erstellt aus den geparsten Funktionen eine Funktionsbibliothek)
    // XML::VERSION::priv_setDocuFunctions  (1.0)
    // XML::RETURN::priv_setDocuFunctions (BOOl)
    function priv_setDocuFunctions()
    {
      while(list($key,$val) = each($this->var_parsed_functions))
      {
		$my_function = $key;
		$my_function_desc = "var_func_".$my_function."_DESC";
		$my_function_ver = "var_func_".$my_function."_VERSION";
		$my_function_author = "var_func_".$my_function."_AUTHOR";
		$my_function_ret = "var_func_".$my_function."_RETURN";
		$my_docu_function = "    <function name=\"".$my_function."\"";

		($this->$my_function_ver) ? ($my_docu_function .= " version=\"".$this->$my_function_ver."\"") : ($dummy);
		($this->$my_function_author) ? ($my_docu_function .= " author=\"".$this->$my_function_author."\"") : ($dummy);
		($this->$my_function_ret) ? ($my_docu_function .= " return=\"".$this->$my_function_ret."\"") : ($dummy);
		($this->$my_function_desc) ? ($my_docu_function .= ">\n      <![CDATA[\n        ".$this->$my_function_desc."\n      ]]>") : ($my_docu_function .= ">\n");
		$my_docu_function .= "\n    </function>\n";

		unset($this->$my_function_desc,$this->$my_function_ver,$this->$my_function_author,$this->$my_function_ret);
	  	$this->var_docu_functions .= $my_docu_function;
	  }
    }

    // XML::FUNC::priv_createDocu ($self->createDocu())
    // XML::DESC::priv_createDocu (Schreibt alle erstellten Daten der Onlinedokumentation in eine Datei)
    // XML::VERSION::priv_createDocu  (1.0)
    // XML::RETURN::priv_createDocu (BOOl)
	function priv_createDocu()
	{
	  // XML::COMMENT (Datei zum Lesen und Schreiben ffnen)
  	  $p_file = fopen($this->output_file,"a+");

  	  fwrite($p_file,$this->var_COMPLETE_DOCU);
  	  fclose($p_file);
	}

  }
?>
