<?php
  // XML::MODUL   (Universal XML-Macros)
  // XML::VERSION (0.035)
  // XML::AUTHOR  (::[CTH]Goldenhawk::)
  // XML::INFO    (CXml erzeugt aus XML-Macros die jeweilige Ausgabe und erstellt aus Strings XML-Tags)


  // XML::COMMENT (Vesrion, Name und Autor festlege)
  $VERSION = "0.035";
  $NAME    = "CXml";
  $AUTHOR  = "::[CTH]Goldenhawk::";

  class CXml
  {
    // XML::FUNC::proofString ($self->proofString($string)
    // XML::DESC::proofString (berprft, ob das angegebene Macro zulssig ist und versucht die passende Funktion aufzurufen)
    // XML::VERSION::proofString  (1.1)
    // XML::RETURN::proofString (BOOl|$string)
    function proofString($m_string)
    {
      // XML::COMMENT (Solange nicht der String geparst wurde, ist return=false)
	  $m_return = -1;

	  // XML::COMMENT (String auf Gltigkeit prfen)
      if (preg_match("/^XML::(.*) \((.*)\)/i",$m_string,$array))
	  {
		// XML::COMMENT (Globale Variablen zuweisen)
		$this->var_line = $array[0];
		$this->var_macro = $array[1];
		$this->var_string = $array[2];
		$var_macro = $array[1];

		// XML::COMMENT (berprfen, ob Methode existiert)
	    if (!method_exists($this,$this->var_macro))
	    {
	      // XML::COMMENT (Allgemeinen Fehlercode festlegen)
	      $this->errcode = "Unknown macro: \"".$this->var_macro."\"";
	    }
	    else
	    {
	      // XML::COMMENT (Macro ausfhren
	      (call_user_method($this->var_macro,$this)) ? ($m_return = 1) : ($this->errcode = "The Macro \"".$this->var_macro."\" did not return TRUE.");
		}
      }
	  // XML::COMMENT (XML-Macrosyntax ist falsch)
      else
      {
        $this->errcode = "The string \"$m_string\" has a corrupt XML-Macrosyntax";
      }

	  // XML::COMMENT (Entweder komplette Line oder Egebnis zurckgeben)
	  if ($m_return == -1)
	    return $this->var_line;
	  else
	    return $this->var_string;
    }

	// XML::FUNC::createXMLHeader ($self->createXMLHeader($opts))
	// XML::DESC::createXMLHeader (Legt den Header einer XML-Datei fest)
	// XML::VERSION::createXMLHeader (1.0)
	// XML::RETURN::createXMLHeader (BOOL)
	function createXMLHeader($opts,$attrs)
	{
	  (!$opts[version]) ? ($opts[version] = "1.0") : ($dummy);
	  (!$opts[encoding]) ? ($opts[encoding] = "UTF-8") : ($dummy);
	  (!$opts[doctype]) ? ($opts[doctype] = "lansystem") : ($dummy);
	  (!$opts[root]) ? ($opts[root] = "lansystem") : ($dummy);

	  // XML::COMMENT (Attribute festlegen)
	  while(list($key,$val) = each($attrs))
	  {
	    $m_attrs .= "$key = \"".$val."\" ";
	  }

	  // XML::COMMENT (Root festlegen)
	  $this->priv_root = $opts[root];
	  $this->xml_file = "<?xml version=\"".$opts[version]."\" encoding=\"".$opts[encoding]."\"?>\n";
	  $this->xml_file .= "<!DOCTYPE ".$opts[doctype].">\n";
	  $this->xml_file .= "<".$this->priv_root." ".$m_attrs.">\n";
	  $this->xml_file .= "<!--START-->\n";

	  return true;
	}

	// XML::FUNC::createXMLFooter ($self->createXMLFooter())
	// XML::DESC::createXMLFooter (Legt den Footer einer XML-Datei fest)
	// XML::VERSION::createXMLFooter (1.0)
	// XML::RETURN::createXMLFooter ($string)
	function createXMLFooter()
	{
	  $this->xml_file .= "\n<!--END-->\n";
	  $this->xml_file .= "</".$this->priv_root.">\n";

	  return $this->xml_file;
	}

    // XML::FUNC::createXMLEntry ($self->createXMLEntry($opts)
    // XML::DESC::createXMLEntry (Erstellt das erste zweite Objekt einer XML-Struktur)
    // XML::VERSION::createXMLEntry  (1.2)
    // XML::RETURN::createXMLEntry ($string|BOOL)
	function createXMLEntry($opts,$attrs)
	{
	  // XML::COMMENT (Tag festlegen)
	  $this->xml_tag = $opts[tag];

	  // XML::COMMENT (Dem Tag die Attribute zuweisen
	  if ($attrs)
	  {
	    while (list($key,$val) = each($attrs))
	    {
	      $this->xml_attrs .= " $key=\"".$val."\"";
	    }
	  }

	  if ($opts[last])
	  {
	    $this->xml_fullentry = "  </".$this->xml_tag.">\n\n";
	  }
	  else
	  {
	    $this->xml_fullentry = "\n  <".$this->xml_tag.$this->xml_attrs.">\n";
	  }

	  unset($attrs,$this->xml_attrs);

	  if ($opts[p_return])
	  {
	    return $this->xml_fullentry;
	  }
	  else
	  {
	    $this->xml_file .= $this->xml_fullentry;
	    $this->xml_fullentry = "";
	    return true;
	  }
	}

    // XML::FUNC::createXMLTag ($self->createXMLTag($opts)
    // XML::DESC::createXMLTag (Erstellt aus dem $opts-Array einen XML-Tag)
    // XML::VERSION::createXMLTag  (1.2)
    // XML::RETURN::createXMLTag ($string)
	function createXMLTag($opts,$attrs)
	{
	  // XML::COMMENT (Tag festlegen)
	  $this->xml_tag = $opts[tag];

	  // XML::COMMENT (Dem Tag die Attribute zuweisen
	  if ($attrs)
	  {
	    while (list($key,$val) = each($attrs))
	    {
	      $this->xml_attrs .= " $key=\"".$val."\"";
	    }
	  }

	  // XML::COMMENT (Falls dem Tag ein Wert zugewiesen wurde)
	  if ($opts[value] || $opts[value] == '0')
	  {
	    // XML::COMMENT (Falls der Wert vom Typ CDATA ist)
	    if ($opts[cdata])
	    {
	      $opts[value] = "\n    <![CDATA[\n      ".$opts[value]."\n    ]]>\n";
	    }
	    else
	    {
	      $opts[value] = "\n      $opts[value]\n";
	    }

	    // XML::COMMENT (Endtag festlegen)
	    $this->xml_endtag = "    </".$this->xml_tag.">";
	  }
	  // XML::COMMENT (Abschlieenden Slash festlegen, falls kein Wert vorhanden ist)
	  else
	  {
	    $this->xml_attrs .= " /";
	  }

	  $this->xml_value = $opts[value];

	  // XML::COMMENT (Tag verknpfen)
	  $this->string_xmlfulltag = "    <".$this->xml_tag.$this->xml_attrs.">".$this->xml_value.$this->xml_endtag."\n";

	  // XML::COMMENT (Variablen undeffen)
	  unset($attrs,$this->xml_tag,$this->xml_attrs,$this->xml_value,$this->xml_endtag);

	  // XML::COMMENT (Werz schlielich zurckliefern)
	  if ($opts[p_return])
	  {
	    return $this->string_xmlfulltag;
	  }
	  else
	  {
	    $this->xml_file .= $this->string_xmlfulltag;
	    return true;
	  }
	}

    // XML::FUNC::makeCDATAshort ($self->makeCDATAshort($string)
    // XML::DESC::makeCDATAshort (lscht die Leerzeichen vor und hinter einem CDATA-String)
    // XML::VERSION::makeCDATAshort  (1.0)
    // XML::RETURN::makeCDATAshort ($string)
	function makeCDATAshort($m_obj)
	{
	  if (is_array($m_obj))
	  {
	    while(list($key,$val) = each($m_obj))
	    {
	      if (preg_match("/(\s*)(.*)(\s*)/",$val,$array))
	  	  {
	        $m_obj[$key] = $array[2];
		  }
		}
	  }
	  else
	  {
	    if (preg_match("/^(\s*)(\w*)(\s*)/",$m_obj,$array))
	  	{
	      $m_obj = $array[2];
		}
	  }
	  return $m_obj;
	}

	// XML::FUNC::rpc_execHack ($self->rpc_execHack($file,$class,$function,$attrs))
	// XML::DESC::rpc_execHack (Fhrt einen Hack aus.)
	// XML::VERSION::rpc_execHack (1.0)
	// XML::RETURN::rpc_execHack (BOOL)
	function rpc_execHack($m_file,$m_class,$m_function,$m_attrs)
	{
	  if (!file_exists($m_file))
	    return -1;

	  include_once($m_file);
	  $ctemp = new $m_class;

	  if (method_exists($ctemp,$m_function))
	    $c_back = call_user_method($m_function,$ctemp,$m_attrs);

	  unset($ctemp);

	  if ($c_back)
		return 1;
	  else
	    return -1;
	 }

	// XML::MACRO::XML2HtmlTags ($self->XML2HtmlTags())
	// XML::DESC::XML2HtmlTags (Wandelt den bergebenen String in einen HTML-Tag um - Erlaubt den Verzicht auf CDATA in XML-Dateien)
	// XML::VERSION::XML2HtmlTags (1.0)
	// XML::RETURN::XML2HtmlTags ($string_in_class)
	function XML2HtmlTags()
	{
      $this->var_string = "&lt;".$this->var_string."&gt;";
	  return true;
	}

	// XML::MACRO::XML2Lower ($self->XML2Lower())
	// XML::DESC::XML2Lower (Wandelt den bergebenen String in Kleinbuchstaben um)
	// XML::VERSION::XML2Lower (1.0)
	// XML::RETURN::XML2Lower ($string_in_class)
	function XML2Lower()
	{
	  $this->var_string = strtolower($this->var_string); 
	  return true;
	}
  }

?>
